# -*- coding: utf-8 -*-
"""PREUBA4.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1bn7uly24qxU2t3to2z22SYHEV30qscfG
"""

from tika import parser
import os

from re import sub
import pandas as pd
from wordcloud import WordCloud
import matplotlib.pyplot as plt
import csv

#Lectura de datos (VARIOS ARCHIVOS- UNIÓN)
files = [x for x in os.listdir('/content/drive/MyDrive/CIRCULO - DATOS NO ESTRUCTURADOS/CODIGOS') if x.endswith('.pdf')]

# Almacenando los reportes de Defensoría del Pueblo en data1
data1 = []
for i in files:
  parsed_pdf =parser.from_file('/content/drive/MyDrive/CIRCULO - DATOS NO ESTRUCTURADOS/CODIGOS/'+i)
  data = parsed_pdf['content']
  data1.append(data)

#Se elimina todos los saltos de linea y se extrae la data
#a1=[]
cuadros=[]
nomp=[]
for i in range(0,len(data1)):
   Start = data1[i].replace("\n", "").index("CONFLICTOS ACTIVOS DESARROLLADOS EN UN SOLO DEPARTAMENTO")
   End = data1[i].replace("\n", "").index("CONFLICTOS SOCIALES DESARROLLADOS EN MÁS DE UN DEPARTAMENTO")
   a1=data1[i].replace("\n", "")[Start:End]
   End2 = files[i].index(".pdf")
   enc=files[i][:End2]
   a1=a1.replace("°","")
   a2=a1.replace("–","")
   a3=a2.replace(enc,"")
   #a4=a3.replace(enc2,"")
   nomp.append(enc)
   cuadros.append(a3)

#lista de nombre de los departamentos
nombres=['Amazonas','Áncash','Apurímac','Arequipa','Ayacucho','Cajamarca','Callao','Cusco','Huancavelica','Huánuco','Ica','Junín','La Libertad','Lambayeque',
         'Lima','Loreto','Madre de Dios','Moquegua','Pasco','Piura','Puno','San Martín', 'Tacna','Tumbes','Ucayali']

for l in range(0,len(nombres)):
  nombres[l]=nombres[l]+' Descripción'

#Contabilizando los informes
k=[]
for i in range(0,len(data1)):
  k.append(str(i))

#Buscar los departamentos que estan en los cuadros del documento
depart_cuadr = dict()
for i in range(0,len(cuadros)):
   cuadro = cuadros[i]
   j=[]
   for depart in nombres:
    if( (depart in cuadro)== False):
        continue;
    else:
        j.append(depart)
    depart_cuadr[k[i]]=j

b=[]
b2=[]
d=depart_cuadr
c=cuadros
df = pd.DataFrame()
departamento =[]
reporte=[]
contenido=[]

for i in range(0,len(data1)):
  #Add = len("Note")
  for j in range(0,len(d[k[i]])-1):
   Start = c[i].index(d[k[i]][j]) #primer departamento
   End = c[i].index(d[k[i]][j+1]) #el que sigue
   b2=c[i][Start:End] #el texto entre los dos
   b.append(b2) #se guarda
   nombre=d[k[i]][j]
   departamento.append(nombre)
   reporte.append(i)
   contenido.append(b2)

  Start = c[i].index(d[k[i]][-1])
  b2=c[i][Start:-1]
  nombre=d[k[i]][-1]
  departamento.append(nombre)
  reporte.append(i)
  contenido.append(b2)

# El numero de casos en cada departamento
vt=[]
n_casos=[]
for i in range(0,len(contenido)):
  subcadena="Tipo:"
  vt=contenido[i].count(subcadena)
  n_casos.append(vt)

import pandas as pd
depart=[]
rep=[]
tipot=[]
conten=[]

for i in range(0,len(n_casos)): #Cada fila

  for j in range(0,n_casos[i]): #Número de departamento
    nombre=departamento[i]
    reporte2=reporte[i]
    depart.append(nombre)
    rep.append(reporte2)
    subcadena ="Tipo:"
    subcadena2 ="Caso:"
    subcadena3 ="Tipo:"
    if  j == 0:
     Start2= contenido[i].index(subcadena)
     End2= contenido[i].find(subcadena2)
     End3= contenido[i].find(subcadena,Start2 + 1)
     tipo=contenido[i][Start2:End2].lower()
     cont=contenido[i][Start2:End3]
     tipot.append(tipo)
     conten.append(cont)
    else:
     Start2= contenido[i].index(subcadena, Start2 + 1)
     End2= contenido[i].find(subcadena2, End2 + 1)
     End3= contenido[i].find(subcadena,Start2 + 1)
     tipo=contenido[i][Start2:End2].lower()
     cont=contenido[i][Start2:End3]
     tipot.append(tipo)
     conten.append(cont)

# Crea un dataframe
report=pd.DataFrame(rep)
depa=pd.DataFrame(depart)
cont_caso=pd.DataFrame(conten)
tipot=pd.DataFrame(tipot)
data_c=pd.concat([report,depa,cont_caso,tipot],axis=1)
data_c=data_c.set_axis(['Pdf', 'Departamento', 'Contenido caso','tipo'], axis=1)

#lista de nombre de los meses y años
meses=['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto', 'septiembre', 'octubre', 'noviembre', 'diciembre']
años=['2000','2001','2002','2003','2004','2005','2006','2007','2008','2009','2010','2011','2012','2013','2014','2015','2016','2017', '2018', '2019', '2020', '2021']

#Buscar los meses que estan en los cuadros del documento
j = []
for i in range(0,len(data_c)):
  cuadro = data_c['fecha'][i]
  k=0
  for mes in meses:
    if( (mes in cuadro)== False):
      k=k+1
      if(k== 12):
        vac=''
        j.append(vac)
      else:
        continue;
    else:
      j.append(mes)
      break;

#Buscar los años que estan en los cuadros del documento
n = []
for i in range(0,len(data_c)):
  cuadro = data_c['fecha'][i]
  k=0
  for año in años:
    if( (año in cuadro)== False):
      k=k+1
      if(k== 22):
        vac=''
        n.append(vac)
      else:
        continue;
    else:
      n.append(año)
      break;

# Eliminar la palabra Descripción
depart=[]
for i in range(0,len(depa)):
  departm=data_c["Departamento"][i].replace(" Descripción", "")
  depart.append(departm)

#Crear un dataframe final
fechat=pd.DataFrame(j)
fechan=pd.DataFrame(n)
depart=pd.DataFrame(depart)
data_f=pd.concat([report,depart,cont_caso,fechat,fechan],axis=1)
data_f=data_f.set_axis(['Pdf', 'Departamento', 'Contenido caso','Mes','Año'], axis=1)

data_f

import nltk
nltk.download()

import nltk
nltk.download('punkt')

nltk.download('stopwords')

from nltk.tokenize import word_tokenize

# Eliminar los signos de exclamación

import re, string
def limpieza_b(texto):
  texto=texto.lower()
  texto=re.sub('\[.*?\]','',texto)
  texto=re.sub('[%s]' % re.escape(string.punctuation),'',texto)
  texto=re.sub('\w*\d\w*]' ,'',texto)
  return texto

## Número de casos por departamento
data_f.groupby("Departamento")["Departamento"].count()

# Limpiar el contenido
for i in range(0,len(data_f)-1):
  #Add = len("Note")

  Texto_c = data_f['Contenido caso'].values[i]
  texto_limpio=limpieza_b(Texto_c)
  texto_tk=word_tokenize(texto_limpio)
  data_f['Contenido caso'].values[i]=texto_tk

# Nube de palabras
import pandas
from nltk.tokenize import word_tokenize, sent_tokenize
from nltk.corpus import stopwords

# Agregar un conjunto de palabras vacias al stop_words
stop_words = set(stopwords.words('spanish'))
stop_words.update(['actores','terciarios','tipo','caso','ubicación','ubicacion','primario','secundario','descripción','hechos','defensoría','defensoria','pueblo','enero','febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto', 'septiembre', 'octubre', 'noviembre', 'diciembre','nuevo','primarios','fecha','siguiente','grupo','asimismo','región','año','mes','asunto','plazo','frente','persona','tema','marco','fin','través','registraron','ana','registraron','día','usuario','favor','informó','secundarios','personas','acordó','respecto','mesa','ingresó','cabo','medida','uso','así','único','encuentran','realizó','usuarios','setiembre','realizará','además','realizar','resultado','punto','espinar','parte'])

# Separación de palabras
text = ""

# iterating through list of rows
for row in data_f['Contenido caso'] :

    # iterating through words in the row
    for word in row :

        # concatenate the words
        text = text + " " + word

wordcloud = WordCloud(width=4800, height=4800,
            stopwords=stop_words).generate(text)

# Nube de palabras
plt.figure(figsize=(20,20))
plt.imshow(wordcloud, interpolation="bilinear")
plt.axis("off")
plt.margins(x=0, y=0)
plt.show()

stop_words=list(stop_words)

text_tokens = word_tokenize(text)

tokens_without_sw = [word for word in text_tokens if not word in stop_words]

# Frecuencia de palabras
texto = text.strip()

from collections import Counter

#palabras = texto.split()
frecuencia = Counter(tokens_without_sw)

for palabra, frec in frecuencia.items():
    print(palabra, frec)

import matplotlib.pyplot as plt

# Obtener las 10 palabras más frecuentes
palabras_frec = frecuencia.most_common(10)

# Convertir a dos listas separadas para graficar
palabras, frecuencias = zip(*palabras_frec)

plt.barh(palabras, frecuencias)
plt.title('Palabras más frecuentes')
plt.xlabel('Palabras')
plt.ylabel('Frecuencia')
plt.show()

nombres=['Amazonas','Áncash','Apurímac','Arequipa','Ayacucho','Cajamarca','Cusco','Huancavelica','Huánuco','Ica','Junín','La Libertad','Lambayeque',
         'Loreto','Madre de Dios','Moquegua','Pasco','Piura','Puno','San Martín', 'Tacna','Tumbes','Ucayali']

from nltk.corpus import stopwords
stop_words = set(stopwords.words('spanish'))

stop_words.update(['amazonas','ancash','apurímac','arequipa','ayacucho','cajamarca','cusco','huancavelica','huánuco','ica','junín','libertad','lambayeque',
         'loreto','madre','dios','moquegua','pasco','piura','puno','martín', 'tacna','tumbes','ucayali','san','distrito','provincia'])

text_dep=[]
tokens_without_sw_dep=[]
for l in range(0,len(nombres)):
  data_dep=data_f[data_f['Departamento']==nombres[l]]
  text_d = ""

  # iterating through list of rows
  for row in data_dep['Contenido caso'] :

     # iterating through words in the row
     for word in row :

         # concatenate the words
         text_d = text_d + " " + word

  #text_dep[l]=text_d

  text_tokens_d = word_tokenize(text_d)


  tokens_without_sw_d = [word for word in text_tokens_d if not word in stop_words]
  tokens_without_sw_dep=pd.DataFrame(tokens_without_sw_d)
  texto = text_d.strip()
  frecuencia = Counter(tokens_without_sw_d)
  #for palabra, frec in frecuencia.items():

  palabras_frec = frecuencia.most_common(15)

  # Convertir a dos listas separadas para graficar
  palabras, frecuencias = zip(*palabras_frec)
  print(nombres[l])
  plt.barh(palabras, frecuencias)
  plt.title('Palabras más frecuentes')
  plt.xlabel('Palabras')
  plt.ylabel('Frecuencia')
  plt.show()

meses=['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto', 'septiembre', 'octubre', 'noviembre', 'diciembre']
años=['2004','2005','2006','2007','2008','2010','2011','2012','2013','2014','2015','2016','2017', '2018', '2019', '2020']

from nltk.corpus import stopwords

stop_words = set(stopwords.words('spanish'))
stop_words.update(['actores','terciarios','tipo','caso','ubicación','ubicacion','primario','secundario','descripción','hechos','defensoría','defensoria','pueblo','enero','febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto', 'septiembre', 'octubre', 'noviembre', 'diciembre','nuevo','primarios','fecha','siguiente','grupo','asimismo','región','año','mes','asunto','plazo','frente','persona','tema','marco','fin','través','registraron','ana','registraron','día','usuario','favor','informó','secundarios','personas','acordó','respecto','mesa','ingresó','cabo','medida','uso','así','único','encuentran','realizó','usuarios','setiembre','realizará','además','realizar','resultado','punto','espinar','parte'])
stop_words.update(['2004','2005','2006','2007','2008','2010','2011','2012','2013','2014','2015','2016','2017', '2018', '2019', '2020'])

text_dep=[]
tokens_without_sw_dep=[]
for l in range(0,len(años)):
  data_dep=data_f[data_f['Año']==años[l]]
  text_d = ""

  # iterating through list of rows
  for row in data_dep['Contenido caso'] :

     # iterating through words in the row
     for word in row :

         # concatenate the words
         text_d = text_d + " " + word

  #text_dep[l]=text_d

  text_tokens_d = word_tokenize(text_d)


  tokens_without_sw_d = [word for word in text_tokens_d if not word in stop_words]
  tokens_without_sw_dep=pd.DataFrame(tokens_without_sw_d)
  texto = text_d.strip()
  frecuencia = Counter(tokens_without_sw_d)
  #for palabra, frec in frecuencia.items():

  palabras_frec = frecuencia.most_common(15)

  # Convertir a dos listas separadas para graficar
  palabras, frecuencias = zip(*palabras_frec)
  print(años[l])
  plt.barh(palabras, frecuencias)
  plt.title('Palabras más frecuentes')
  plt.xlabel('Palabras')
  plt.ylabel('Frecuencia')
  plt.show()

text_dep=[]
tokens_without_sw_dep=[]
for l in range(0,len(meses)):
  data_dep=data_f[data_f['Mes']==meses[l]]
  text_d = ""

  # iterating through list of rows
  for row in data_dep['Contenido caso'] :

     # iterating through words in the row
     for word in row :

         # concatenate the words
         text_d = text_d + " " + word

  #text_dep[l]=text_d

  text_tokens_d = word_tokenize(text_d)


  tokens_without_sw_d = [word for word in text_tokens_d if not word in stop_words]
  tokens_without_sw_dep=pd.DataFrame(tokens_without_sw_d)
  texto = text_d.strip()
  frecuencia = Counter(tokens_without_sw_d)
  #for palabra, frec in frecuencia.items():

  palabras_frec = frecuencia.most_common(15)

  # Convertir a dos listas separadas para graficar
  palabras, frecuencias = zip(*palabras_frec)
  print(meses[l])
  plt.barh(palabras, frecuencias)
  plt.title('Palabras más frecuentes')
  plt.xlabel('Palabras')
  plt.ylabel('Frecuencia')
  plt.show()

import nltk
w = tokens_without_sw

words = [w for w in w if w.isalpha()]
fd = nltk.FreqDist(words)

fd.tabulate(3)

lower_fd = nltk.FreqDist([w.lower() for w in fd])

"""Extracción de concordancias y colocaciones"""

#Extracción de concordancias y colocaciones
text1 = nltk.Text(words)
text1.concordance("ministerio", lines=5)

finder = nltk.collocations.TrigramCollocationFinder.from_words(words)
finder2 = nltk.collocations.BigramCollocationFinder.from_words(words)

finder.ngram_fd.most_common(10)

finder2.ngram_fd.most_common(10)